(window.webpackJsonp=window.webpackJsonp||[]).push([[43],{147:function(e,t,o){"use strict";o.r(t);var a=o(0),n=function(e){var t,o,a,n,i,r,s,l,c=(t="Software Engineering",o=void 0,i="软件工程",r="refactoring",s="legacy code",l="programming",(a={}).type=n="post",a.internal=o,a.contentType="markdown",a.slug="legacy-code-best-practice-how-to-take-over-an-existing-project-smoothly",a.content=o,a.createdAt=new Date(16116774e5),a.updatedAt=new Date(1611755596583),a.layout=n,a.title="Legacy code best practice: how to take over an existing project smoothly",a.date="2021-01-27 00:10:00",a.categories=[t],a.tags=[t,i,"重构",r,s,l],a.markdownHeadings=[{text:"1. Ask for documentation or explanation",slug:"1--ask-for-documentation-or-explanation",level:2},{text:"2. Fix minor bugs",slug:"2--fix-minor-bugs",level:2},{text:"3. Keep new code clean",slug:"3--keep-new-code-clean",level:2},{text:"4. Only rewrite code when necessary",slug:"4--only-rewrite-code-when-necessary",level:2},{text:"5. Modularize code to the minimum possible",slug:"5--modularize-code-to-the-minimum-possible",level:2},{text:"6. Refactor after modularization",slug:"6--refactor-after-modularization",level:2},{text:"Conclusion",slug:"conclusion",level:2}],a.excerpt="<p>Every programmer, I guess, would meet the code from others that you have never contributed to. And one of the ways to distinguish experienced programmers from beginners is to see if they can quickly dive into the legacy code and maintain, develop, and refactor it in the right way.</p>\n",a.permalink="/2021/01/27/legacy-code-best-practice-how-to-take-over-an-existing-project-smoothly",a.assets={},a.attributes=a,a.tagsInfo=[{name:t,permalink:"/tags/software-engineering"},{name:i,permalink:"/tags/软件工程"},{name:"重构",permalink:"/tags/重构"},{name:r,permalink:"/tags/refactoring"},{name:s,permalink:"/tags/legacy-code"},{name:l,permalink:"/tags/programming"}],a.categoriesInfo=[{name:t,permalink:"/categories/software-engineering"}],a.prevPost={title:"2020 恍如隔世",permalink:"/2021/01/05/2020-summary"},a.nextPost=o,a),d=e.options.beforeCreate||[];e.options.beforeCreate=[function(){this.$page=c}].concat(d);["layout","transition"].forEach((function(t){var o=e.options.PageComponent;o&&(e.options[t]=o[t]),void 0===e.options[t]&&(e.options[t]=c[t])})),c.slug&&(e.options.name="page-wrapper-"+c.slug.replace(/[^0-9a-z\-]/gi,"-"))},i=Object(a.a)({},(function(){var e=this,t=e.$createElement,o=e._self._c||t;return o("layout-manager",[o("p",[e._v("Every programmer, I guess, would meet the code from others that you have never contributed to. And one of the ways to distinguish experienced programmers from beginners is to see if they can quickly dive into the legacy code and maintain, develop, and refactor it in the right way.")]),e._v(" "),o("p",[e._v("There is no silver bullet to approach it, I’ve also been caught in the nightmare of not being able to read the code at all. But I have some tips from my experience to guide you to master it step by step. Hope it would be helpful.")]),e._v(" "),o("h2",{attrs:{id:"1--ask-for-documentation-or-explanation"}},[e._v("1. Ask for documentation or explanation")]),e._v(" "),o("p",[e._v("It’s very lucky if there is some detailed documentation, or if the person who wrote the code is still around. This can save you a lot of time, but of course the best way is that the previous team can help you walk through the whole codebase.")]),e._v(" "),o("p",[e._v("In this stage, you’d better know:")]),e._v(" "),o("ul",[o("li",[e._v("how to "),o("strong",[e._v("run")]),e._v(" the whole project code")]),e._v(" "),o("li",[e._v("any easier way to "),o("strong",[e._v("test")]),e._v(" or "),o("strong",[e._v("debug")]),e._v(" during development")]),e._v(" "),o("li",[e._v("the "),o("strong",[e._v("version control")]),e._v(" tool they used")]),e._v(" "),o("li",[e._v("how to "),o("strong",[e._v("release")]),e._v(" and "),o("strong",[e._v("deploy")])]),e._v(" "),o("li",[e._v("any "),o("strong",[e._v("dependent")]),e._v(" library you should notice")])]),e._v(" "),o("p",[e._v("if there are no docs and no person was responsible for it available, promise me, please do not get angry and smash your keyboard :)")]),e._v(" "),o("p",[o("saber-image",{attrs:{src:"https://geekpluxblog.oss-cn-hongkong.aliyuncs.com/legacy-code/smash%20keyboard.gif",alt:"smash keyboard panda","data-lazy":"{}"}})],1),e._v(" "),o("h2",{attrs:{id:"2--fix-minor-bugs"}},[e._v("2. Fix minor bugs")]),e._v(" "),o("p",[e._v("Learn by doing is always the fastest way to master code. For instance, if the legacy code is for the front-end, you can just change the Button style, if it’s for the back-end, you can just replace the response, that’s the easy but effective method to:")]),e._v(" "),o("ul",[o("li",[e._v("know and practice how to "),o("strong",[e._v("debug")]),e._v(" during developing")]),e._v(" "),o("li",[e._v("know each function’s purpose and its "),o("strong",[e._v("scope")]),e._v(", roughly")])]),e._v(" "),o("p",[e._v("These small bugs or tweaks allow you to get better familiar with the code, especially if you are really confused and have no idea how to start.")]),e._v(" "),o("h2",{attrs:{id:"3--keep-new-code-clean"}},[e._v("3. Keep new code clean")]),e._v(" "),o("p",[e._v("If you do not want to make things more complicated, then keep your new code clean. To follow the "),o("saber-link",{attrs:{to:"https://www.wikiwand.com/en/Unix_philosophy"}},[e._v("Unix philosophy")]),e._v(", "),o("strong",[e._v("make each function do one thing and do it well")]),e._v(".")],1),e._v(" "),o("p",[e._v("You can’t control the quality of the inherited code, but you can make sure the code you add is the style you love.")]),e._v(" "),o("h2",{attrs:{id:"4--only-rewrite-code-when-necessary"}},[e._v("4. Only rewrite code when necessary")]),e._v(" "),o("p",[e._v("I know every developer can’t help trying to rewrite the legacy code, but it usually brings much "),o("strong",[e._v("undesirable")]),e._v(" behavior.")]),e._v(" "),o("p",[e._v("Every time when I have to rewrite some functions, I will imagine the code taken over is a black box full of magic (and it always is!) so that I will be careful with each input and output.")]),e._v(" "),o("p",[e._v("When it comes to interdependent functions, try to control the scope of their impact, change the code as little as possible, try to ensure that no new bugs are introduced, and keep smooth iterative development.")]),e._v(" "),o("h2",{attrs:{id:"5--modularize-code-to-the-minimum-possible"}},[e._v("5. Modularize code to the minimum possible")]),e._v(" "),o("p",[e._v("Maintaining and developing the legacy code is a progressive process. When you have to rewrite it, don’t rush to completely overturn the previous code first, try to take it apart first.")]),e._v(" "),o("p",[e._v("Dividing code makes you understand the code logic totally. You could keep the input params and output as simple as possible. "),o("strong",[e._v("Roughly split first, and then split again on top of that until it is minimized")]),e._v(".")]),e._v(" "),o("p",[e._v("The advantage of this step is that any future refactoring of your code will also bring minimal impact.")]),e._v(" "),o("p",[o("saber-image",{attrs:{src:"https://geekpluxblog.oss-cn-hongkong.aliyuncs.com/legacy-code/james-pond-riEYPSKxoTw-unsplash.jpg",alt:"modularize like lego","data-lazy":"{}"}})],1),e._v(" "),o("h2",{attrs:{id:"6--refactor-after-modularization"}},[e._v("6. Refactor after modularization")]),e._v(" "),o("p",[e._v("Best practices for refactoring are written in many books, but I still recommend doing it on top of completing the previous step. Which will take weeks, months or possibly years depending on the complexity.")]),e._v(" "),o("p",[e._v("At the same time you need to keep up with the speed of developing new features, so it’s a "),o("strong",[e._v("trade-off")]),e._v(". I know that refactoring parts of the legacy code can improve the speed of writing new code, but it can also be more of a burden. It needs much patience to take your time and get the refactoring done.")]),e._v(" "),o("h2",{attrs:{id:"conclusion"}},[e._v("Conclusion")]),e._v(" "),o("p",[e._v("In short, "),o("strong",[e._v("don’t rush to overturn all the old code, but change it little by little, modularize and optimize it")]),e._v(". Which like eating a pie, starting from the edges and working your way to the core, little by little.")])])}),[],!1,null,null,null);"function"==typeof n&&n(i);t.default=i.exports}}]);