(window.webpackJsonp=window.webpackJsonp||[]).push([[56],{160:function(t,e,s){"use strict";s.r(e);var n=s(0),a=function(t){var e,s,n,a,r,p,o=(e="Code",a=void 0,r="Summary",p="Note",(s={}).type=n="post",s.internal=a,s.contentType="markdown",s.slug="pointer_references",s.content=a,s.createdAt=new Date(1357112485e3),s.updatedAt=new Date(1594043277805),s.layout=n,s.title="C++指针与引用小结",s.date="2013-01-02 15:41:25",s.categories=[e],s.tags=[e,"编程","总结",r,"笔记",p],s.markdownHeadings=[{text:"概念",slug:"概念",level:2},{text:"引用",slug:"引用",level:3},{text:"指针",slug:"指针",level:3},{text:"联系",slug:"联系",level:2},{text:"区别",slug:"区别",level:2}],s.excerpt='<h2 id="概念"><strong>概念</strong></h2>\n<h3 id="引用"><strong>引用</strong></h3>\n<p><strong>引用</strong>就是某一对象（变量）的一个<strong>别名</strong>。举个例子更容易理解：</p>\n<div class="saber-highlight" v-pre="" data-lang="cpp"><pre class="saber-highlight-code language-cpp"><code class="language-cpp"><span class="token keyword">int</span> m<span class="token punctuation">;</span>\n<span class="token keyword">int</span> <span class="token operator">&amp;</span>n <span class="token operator">=</span> m<span class="token punctuation">;</span></code></pre></div><p>这段程序中，<code v-pre="">n</code>是<code v-pre="">m</code>的一个引用（reference），<code v-pre="">m</code>是被引用物（referent）。\n<code v-pre="">n</code>相当于<code v-pre="">m</code>的<strong>别名</strong>（绰号），对<code v-pre="">n</code>的任何操作就是对<code v-pre="">m</code>的操作。\n<code v-pre="">n</code>既不是<code v-pre="">m</code>的拷贝，也不是指向<code v-pre="">m</code>的指针，其实<code v-pre="">n</code>就是<code v-pre="">m</code>它自己。</p>\n<h3 id="指针"><strong>指针</strong></h3>\n<blockquote>\n<p><strong>指针</strong>用于指向对象（变量）。指针提供对其所指对象的间接访问。指针用于指向单个对象。</p>\n</blockquote>\n<p>（这三句摘自《C++ Primer, Fourth Edition》）。再举个例子：</p>\n<div class="saber-highlight" v-pre="" data-lang="cpp"><pre class="saber-highlight-code language-cpp"><code class="language-cpp"><span class="token keyword">int</span> m<span class="token punctuation">;</span>\n<span class="token keyword">int</span> <span class="token operator">*</span>n <span class="token operator">=</span> <span class="token operator">&amp;</span>m<span class="token punctuation">;</span></code></pre></div><p>第二条语句定义了一个指向<code v-pre="">int</code>型的指针<code v-pre="">n</code>，并初始化<code v-pre="">n</code>使其指向<code v-pre="">int</code>型的变量<code v-pre="">m</code>。\n<code v-pre="">*n</code>中的 <code v-pre="">*</code> 操作符表明<code v-pre="">n</code>是一个指针变量（<strong><code v-pre="">n</code>本质上也是一个变量，只不过这个变量的存储内容是 地址</strong>）。\n<code v-pre="">&amp;m</code>中的 <code v-pre="">&amp;</code> 符号是<strong>取地址操作符</strong>，当此操作符用于一个对象上时，返回的是该对象的存储地址。</p>\n',s.permalink="/2013/01/02/pointer_references",s.assets={},s.attributes=s,s.tagsInfo=[{name:e,permalink:"/tags/code"},{name:"编程",permalink:"/tags/编程"},{name:"总结",permalink:"/tags/总结"},{name:r,permalink:"/tags/summary"},{name:"笔记",permalink:"/tags/笔记"},{name:p,permalink:"/tags/note"}],s.categoriesInfo=[{name:e,permalink:"/categories/code"}],s.prevPost={title:"该不该制定计划",permalink:"/2012/10/25/plan_or_not"},s.nextPost={title:"操作系统总结——引论",permalink:"/2013/01/03/os_introduction"},s),v=t.options.beforeCreate||[];t.options.beforeCreate=[function(){this.$page=o}].concat(v);["layout","transition"].forEach((function(e){var s=t.options.PageComponent;s&&(t.options[e]=s[e]),void 0===t.options[e]&&(t.options[e]=o[e])})),o.slug&&(t.options.name="page-wrapper-"+o.slug.replace(/[^0-9a-z\-]/gi,"-"))},r=Object(n.a)({},(function(){var t=this,e=t.$createElement,s=t._self._c||e;return s("layout-manager",[s("h2",{attrs:{id:"概念"}},[s("strong",[t._v("概念")])]),t._v(" "),s("h3",{attrs:{id:"引用"}},[s("strong",[t._v("引用")])]),t._v(" "),s("p",[s("strong",[t._v("引用")]),t._v("就是某一对象（变量）的一个"),s("strong",[t._v("别名")]),t._v("。举个例子更容易理解：")]),t._v(" "),s("div",{pre:!0,attrs:{class:"saber-highlight","data-lang":"cpp"}},[s("pre",{pre:!0,attrs:{class:"saber-highlight-code language-cpp"}},[s("code",{pre:!0,attrs:{class:"language-cpp"}},[s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("int")]),t._v(" m"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("int")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("&")]),t._v("n "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("=")]),t._v(" m"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")])])])]),s("p",[t._v("这段程序中，"),s("code",{pre:!0},[t._v("n")]),t._v("是"),s("code",{pre:!0},[t._v("m")]),t._v("的一个引用（reference），"),s("code",{pre:!0},[t._v("m")]),t._v("是被引用物（referent）。\n"),s("code",{pre:!0},[t._v("n")]),t._v("相当于"),s("code",{pre:!0},[t._v("m")]),t._v("的"),s("strong",[t._v("别名")]),t._v("（绰号），对"),s("code",{pre:!0},[t._v("n")]),t._v("的任何操作就是对"),s("code",{pre:!0},[t._v("m")]),t._v("的操作。\n"),s("code",{pre:!0},[t._v("n")]),t._v("既不是"),s("code",{pre:!0},[t._v("m")]),t._v("的拷贝，也不是指向"),s("code",{pre:!0},[t._v("m")]),t._v("的指针，其实"),s("code",{pre:!0},[t._v("n")]),t._v("就是"),s("code",{pre:!0},[t._v("m")]),t._v("它自己。")]),t._v(" "),s("h3",{attrs:{id:"指针"}},[s("strong",[t._v("指针")])]),t._v(" "),s("blockquote",[s("p",[s("strong",[t._v("指针")]),t._v("用于指向对象（变量）。指针提供对其所指对象的间接访问。指针用于指向单个对象。")])]),t._v(" "),s("p",[t._v("（这三句摘自《C++ Primer, Fourth Edition》）。再举个例子：")]),t._v(" "),s("div",{pre:!0,attrs:{class:"saber-highlight","data-lang":"cpp"}},[s("pre",{pre:!0,attrs:{class:"saber-highlight-code language-cpp"}},[s("code",{pre:!0,attrs:{class:"language-cpp"}},[s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("int")]),t._v(" m"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("int")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("*")]),t._v("n "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("=")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("&")]),t._v("m"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")])])])]),s("p",[t._v("第二条语句定义了一个指向"),s("code",{pre:!0},[t._v("int")]),t._v("型的指针"),s("code",{pre:!0},[t._v("n")]),t._v("，并初始化"),s("code",{pre:!0},[t._v("n")]),t._v("使其指向"),s("code",{pre:!0},[t._v("int")]),t._v("型的变量"),s("code",{pre:!0},[t._v("m")]),t._v("。\n"),s("code",{pre:!0},[t._v("*n")]),t._v("中的 "),s("code",{pre:!0},[t._v("*")]),t._v(" 操作符表明"),s("code",{pre:!0},[t._v("n")]),t._v("是一个指针变量（"),s("strong",[s("code",{pre:!0},[t._v("n")]),t._v("本质上也是一个变量，只不过这个变量的存储内容是 地址")]),t._v("）。\n"),s("code",{pre:!0},[t._v("&m")]),t._v("中的 "),s("code",{pre:!0},[t._v("&")]),t._v(" 符号是"),s("strong",[t._v("取地址操作符")]),t._v("，当此操作符用于一个对象上时，返回的是该对象的存储地址。")]),t._v(" "),s("h2",{attrs:{id:"联系"}},[s("strong",[t._v("联系")])]),t._v(" "),s("ul",[s("li",[t._v("都是有关地址的概念。\n指针指向一块内存，它的内容是所指内存的地址；而引用则是某块内存的别名。")]),t._v(" "),s("li",[t._v("都是间接访问其他对象。")]),t._v(" "),s("li",[t._v("都能用于函数参数和返回值的传递。")])]),t._v(" "),s("h2",{attrs:{id:"区别"}},[s("strong",[t._v("区别")])]),t._v(" "),s("ul",[s("li",[s("strong",[t._v("一、指针是一个实体（本质上就是存放变量地址的一个变量），而引用只是个别名。")])])]),t._v(" "),s("p",[t._v("这句话从内存分配的角度很好理解，程序会为指针变量分配内存区域，而引用不分配内存区域。")]),t._v(" "),s("ul",[s("li",[s("strong",[t._v("二、指针可变，引用不可变。")])])]),t._v(" "),s("p",[t._v("指针在逻辑上是独立的，它可以被改变，包括其所指向的地址的改变和其指向的地址中所存放的数据的改变。\n引用在逻辑上不独立，具有依附性，所以引用必须在一开始就被初始化，而且引用一旦和某个对象绑定后就不能再改变（从一而终）。")]),t._v(" "),s("ul",[s("li",[s("strong",[t._v("三、指针可以为空，引用不能为空。")])])]),t._v(" "),s("p",[t._v("即指针可以为 NULL，而引用必须与合法的存储单元关联。")]),t._v(" "),s("ul",[s("li",[s("strong",[t._v("四、传递方式不同。")])])]),t._v(" "),s("p",[t._v("首先，函数参数和返回值的传递方式大概可以理解为三种：")]),t._v(" "),s("ol",[s("li",[t._v("值传递")]),t._v(" "),s("li",[t._v("指针传递")]),t._v(" "),s("li",[t._v("引用传递")])]),t._v(" "),s("p",[t._v("先理解"),s("strong",[t._v("值传递")]),t._v("：值传递过程中，被调函数的形式参数作为被调函数的局部变量处理，即在栈中开辟了内存空间以存放由主调函数放进来的实参的值，从而成为了实参的一个拷贝。"),s("em",[t._v("值传递的特点是被调函数对形式参数的任何操作都是作为局部变量进行，不会影响主调函数的实参变量的值。")])]),t._v(" "),s("p",[s("strong",[t._v("指针传递")]),t._v("本质上值传递，只不过它所传递的是一个地址值。然后把上面那段话「翻译」一下：指针传递时，形参是一个指针变量，该变量拷贝了实参的地址值，然后作为被调函数的局部变量（传递过来的实参的地址值不会变），再然后我们可以用"),s("code",{pre:!0},[t._v("*")]),t._v("操作符访问实参，从而对实参进行操作。很绕口，不如看个例子：")]),t._v(" "),s("div",{pre:!0,attrs:{class:"saber-highlight","data-lang":"cpp"}},[s("pre",{pre:!0,attrs:{class:"saber-highlight-code language-cpp"}},[s("code",{pre:!0,attrs:{class:"language-cpp"}},[s("span",{pre:!0,attrs:{class:"token macro property"}},[t._v("#"),s("span",{pre:!0,attrs:{class:"token directive keyword"}},[t._v("include")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token string"}},[t._v("<iostream>")])]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("using")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("namespace")]),t._v(" std"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n\n"),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("void")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token function"}},[t._v("f")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("(")]),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("int")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("*")]),t._v("n"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(")")]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("{")]),t._v("\n  "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("*")]),t._v("n "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("=")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token number"}},[t._v("5")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("}")]),t._v("\n\n"),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("int")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token function"}},[t._v("main")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("(")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(")")]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("{")]),t._v("\n  "),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("int")]),t._v(" m "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("=")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token number"}},[t._v("1")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n  cout "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("<<")]),t._v(" m "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("<<")]),t._v(" endl"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n  "),s("span",{pre:!0,attrs:{class:"token function"}},[t._v("f")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("(")]),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("&")]),t._v("m"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(")")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n  cout "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("<<")]),t._v(" m "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("<<")]),t._v(" endl"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n\n  "),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("return")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token number"}},[t._v("0")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("}")])])])]),s("p",[t._v("该程序输出结果为：1 5")]),t._v(" "),s("p",[t._v("在函数"),s("code",{pre:!0},[t._v("f")]),t._v("中，形参"),s("code",{pre:!0},[t._v("n")]),t._v("是指向"),s("code",{pre:!0},[t._v("int")]),t._v("型的指针变量，拷贝了实参"),s("code",{pre:!0},[t._v("m")]),t._v("的地址，作为"),s("code",{pre:!0},[t._v("f")]),t._v("函数的局部变量，然后通过"),s("code",{pre:!0},[t._v("*n")]),t._v("改变实参"),s("code",{pre:!0},[t._v("m")]),t._v("的值。")]),t._v(" "),s("p",[t._v("而在"),s("strong",[t._v("引用传递")]),t._v("过程中，被调函数的形式参数虽然也作为局部变量在栈中开辟了内存空间，但是这时存放的是"),s("strong",[t._v("由主调函数放进来的实参变量的地址")]),t._v("。被调函数对形参的任何操作都被处理成间接寻址（不必通过*操作符），即通过栈中存放的地址访问主调函数中的实参变量。正因为如此，被调函数对形参做的任何操作都影响了主调函数中的实参变量（此时的形参其实就是实参）。再举个例子：")]),t._v(" "),s("div",{pre:!0,attrs:{class:"saber-highlight","data-lang":"cpp"}},[s("pre",{pre:!0,attrs:{class:"saber-highlight-code language-cpp"}},[s("code",{pre:!0,attrs:{class:"language-cpp"}},[s("span",{pre:!0,attrs:{class:"token macro property"}},[t._v("#"),s("span",{pre:!0,attrs:{class:"token directive keyword"}},[t._v("include")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token string"}},[t._v("<iostream>")])]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("using")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("namespace")]),t._v(" std"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n\n"),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("void")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token function"}},[t._v("f")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("(")]),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("int")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("&")]),t._v("n"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(")")]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("{")]),t._v("\n  n "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("=")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token number"}},[t._v("5")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("}")]),t._v("\n\n"),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("int")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token function"}},[t._v("main")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("(")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(")")]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("{")]),t._v("\n  "),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("int")]),t._v(" m "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("=")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token number"}},[t._v("1")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n  cout "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("<<")]),t._v(" m "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("<<")]),t._v(" endl"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n  "),s("span",{pre:!0,attrs:{class:"token function"}},[t._v("f")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("(")]),t._v("m"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(")")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n  cout "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("<<")]),t._v(" m "),s("span",{pre:!0,attrs:{class:"token operator"}},[t._v("<<")]),t._v(" endl"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n\n  "),s("span",{pre:!0,attrs:{class:"token keyword"}},[t._v("return")]),t._v(" "),s("span",{pre:!0,attrs:{class:"token number"}},[t._v("0")]),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v(";")]),t._v("\n"),s("span",{pre:!0,attrs:{class:"token punctuation"}},[t._v("}")])])])]),s("p",[t._v("输出结果为：1 5")]),t._v(" "),s("p",[s("code",{pre:!0},[t._v("n")]),t._v("是"),s("code",{pre:!0},[t._v("f")]),t._v("中的局部变量，同时"),s("code",{pre:!0},[t._v("n")]),t._v("也是实参"),s("code",{pre:!0},[t._v("m")]),t._v("的引用。此时"),s("code",{pre:!0},[t._v("n")]),t._v("就为"),s("code",{pre:!0},[t._v("m")]),t._v("，所以在"),s("code",{pre:!0},[t._v("f")]),t._v("中对"),s("code",{pre:!0},[t._v("n")]),t._v("的操作都会影响"),s("code",{pre:!0},[t._v("m")]),t._v("，为"),s("code",{pre:!0},[t._v("n")]),t._v("赋值 5 就是对"),s("code",{pre:!0},[t._v("m")]),t._v("赋值 5。")]),t._v(" "),s("p",[t._v("还可以从编译角度理解（此处从网上摘录）：")]),t._v(" "),s("blockquote",[s("p",[t._v("程序在编译时分别将指针和引用添加到符号表上，符号表上记录的是变量名及变量所对应地址。指针变量在符号表上对应的地址值为指针变量的地址值，而引用在符号表上对应的地址值为引用对象的地址值。符号表生成后就不会再改，因此指针可以改变其指向的对象（指针变量中的值可以改），而引用对象则不能修改。")])]),t._v(" "),s("ul",[s("li",[s("p",[s("strong",[t._v("五、引用不能 const，指针能 const，const 的指针不可变。")]),t._v("\n对于引用，具体指没有 int&const a 这种形式，而 const int& a 是有的， 前者指引用本身（即别名）不可以改变，这是理所当然的，所以不需要这种形式，后者指引用所指的值不可以改变）")])]),t._v(" "),s("li",[s("p",[s("strong",[t._v("六、「sizeof 引用」得到的是所指向的变量(对象)的大小，而“sizeof 指针”得到的是指针本身的大小。")])])]),t._v(" "),s("li",[s("p",[s("strong",[t._v("七、指针和引用的自增(++)运算意义不一样（很好理解）。")])])])]),t._v(" "),s("p",[t._v("要理解知识必须先建立知识的结构，就像盖楼房一样，必须先有框架，所以此处附上本人制作的一幅简单的思维导图：")]),t._v(" "),s("p",[s("saber-image",{attrs:{src:"https://geekpluxblog.oss-cn-hongkong.aliyuncs.com/pointer-summary.jpg?x-oss-process=style/zip",alt:"","data-lazy":'{"x-oss-process":"style/zip"}'}})],1)])}),[],!1,null,null,null);"function"==typeof a&&a(r);e.default=r.exports}}]);